' Embeds all text files in an open publication
' EmbedAllTextFiles.csc
'
' Copyright 2002 Abe Hendin <ventura@yourspeed.com>
' Initial release, November 17, 2002
' Version 1.0
' Release 1.0.1: November 17, 2002.
'      *Set page layout view before script exection.

' NOTES: This script works only in Ventura 10 (Ventura 8 does not include the
' key command, .TextFileEmbed). The operation cannot be undone unless you close
' the publication without saving afterwards, so please be careful. You will be
' prompted with this warning when the script starts, and have the opportunity
' to cancel.

WITHOBJECT "CorelVentura.Automation.10"
	Dim retval As Integer
	Dim PubName As String
	Dim ChapCount As Long, FileCount As Long, TotalFileCount As Long
	Dim IChap As Long, IFile As Long
	Dim FileName As String
	Dim EmbedCount As Long, AlreadyEmbeddedCount As Long
	
	On Error Resume Next
	PubName = .PublicationName()
	If ErrNum = 1002 Then
		retval = MessageBox("You must open a publication before you can use this script.  ", \\
			"Error: No open publication", 0 Or 48)
	ElseIf Len(PubName) > 0 Then 'start script
		retval = MessageBox("This script will embed all text files in the current" + \\
			CHR(13) + "publication. This operation can ONLY be undone  " + \\
			CHR(13) + "by closing the publication without saving." + CHR(13) + \\
			CHR(13) + "Are you sure you want to embed all text files?", \\
			"Embed all text files?", 3 Or 48)
		
		If retval = 6 Then 'if Yes, execute
			EmbedCount = 0
			AlreadyEmbeddedCount = 0
			TotalFileCount = 0
			
			.ViewPageLayout
			.ViewGotoPage , , 2, 0 'start on first page of pub
			ChapCount = .ChapterCount()
			For IChap = 1 To ChapCount
				FileCount = .TextFileCount()
				For IFile = 1 To FileCount
					FileName = .TextFileGetAt(IFile)
					
					'embeds the file only if not already embedded
					If InStr(FileName, "\") > 0 Then
						.TextFileEmbed FileName
						EmbedCount = EmbedCount + 1
					Else
						AlreadyEmbeddedCount = AlreadyEmbeddedCount + 1
					End If
				Next IFile
				TotalFileCount = TotalFileCount + FileCount
				.ViewGotoPage , , , 6 'go to next chapter
			Next IChap
			.ViewGotoPage , , 2, 0 'return to first page of pub
			Message Ltrim(Str(AlreadyEmbeddedCount)) + \\
				" text files were already embedded." + \\
				CHR(13) + Ltrim(Str(EmbedCount)) + " additional files have been embedded.  " + \\
				CHR(13) + CHR(13) + "All " + Ltrim(Str(TotalFileCount)) + \\
				" text files are now embedded."
		Else 'user cancelled
			Message "Script cancelled."
		End If
	Else 'unknown error
		Message "An unknown error (" + Ltrim(Str(ErrNum)) + ") has occurred."
	End If
END WITHOBJECT
